import{s as Te,n as ve,o as _e}from"../chunks/scheduler.0f20f9e5.js";import{S as Ce,i as Le,g as o,s as a,r as P,A as Me,h as l,f as i,c as s,j as $e,u as z,x as r,k as we,y as He,a as n,v as A,d as B,t as J,w as R}from"../chunks/index.fbd8b8e3.js";import{C as xe}from"../chunks/CodeBlock.c14486c2.js";import{H as k}from"../chunks/Heading.2451f3bb.js";function Pe(oe){let f,X,q,Z,p,F,m,le="With Transformers it’s very easy to load any model in 4 or 8-bit, quantizing them on the fly with bitsandbytes primitives.",I,c,re='Please review the <a href="https://huggingface.co/docs/transformers/v4.37.2/en/quantization#bitsandbytes" rel="nofollow">bitsandbytes section in the Accelerate docs</a>.',j,d,fe='Details about the BitsAndBytesConfig can be found here](<a href="https://huggingface.co/docs/transformers/v4.37.2/en/main_classes/quantization#transformers.BitsAndBytesConfig" rel="nofollow">https://huggingface.co/docs/transformers/v4.37.2/en/main_classes/quantization#transformers.BitsAndBytesConfig</a>).',Q,u,U,b,pe="If your hardware supports it, <code>bf16</code> is the optimal compute dtype. The default is <code>float32</code> for backward compatibility and numerical stability. <code>float16</code> often leads to numerical instabilities, but <code>bfloat16</code> provides the benefits of both worlds: numerical stability and significant computation speedup. Therefore, be sure to check if your hardware supports <code>bf16</code> and configure it using the <code>bnb_4bit_compute_dtype</code> parameter in BitsAndBytesConfig:",N,h,S,g,V,y,me="With <code>PEFT</code>, you can use QLoRA out of the box with <code>LoraConfig</code> and a 4-bit base model.",W,$,ce='Please review the <a href="https://huggingface.co/docs/peft/developer_guides/quantization#quantize-a-model" rel="nofollow">bitsandbytes section in the Accelerate docs</a>.',G,w,Y,T,de="Bitsandbytes is also easily usable from within Accelerate.",D,v,ue='Please review the <a href="https://huggingface.co/docs/accelerate/en/usage_guides/quantization" rel="nofollow">bitsandbytes section in the Accelerate docs</a>.',K,_,O,C,be="You can use any of the 8-bit and/or paged optimizers by simple passing them to the <code>transformers.Trainer</code> class on intialization.All bnb optimizers are supported by passing the correct string in <code>TrainingArguments</code>’s <code>optim</code> attribute - e.g. (<code>paged_adamw_32bit</code>).",ee,L,he='See the <a href="https://huggingface.co/docs/transformers/main_classes/trainer#transformers.Trainer" rel="nofollow">official API docs for reference</a>.',te,M,ge=`Here we point out to relevant doc sections in transformers / peft / Trainer + very briefly explain how these are integrated:
e.g. for transformers state that you can load any model in 8-bit / 4-bit precision, for PEFT, you can use QLoRA out of the box with <code>LoraConfig</code> + 4-bit base model, for Trainer: all bnb optimizers are supported by passing the correct string in <code>TrainingArguments</code>’s <code>optim</code> attribute - e.g. (<code>paged_adamw_32bit</code>):`,ie,H,ne,x,ye='<li><a href="https://huggingface.co/blog/4bit-transformers-bitsandbytes" rel="nofollow">Making LLMs even more accessible with bitsandbytes, 4-bit quantization and QLoRA</a></li> <li><a href="https://huggingface.co/blog/hf-bitsandbytes-integration" rel="nofollow">A Gentle Introduction to 8-bit Matrix Multiplication for transformers at scale using Hugging Face Transformers, Accelerate and bitsandbytes</a></li>',ae,E,se;return p=new k({props:{title:"Transformers",local:"transformers",headingTag:"h1"}}),u=new k({props:{title:"Beware: bf16 is optional compute data type",local:"beware-bf16-is-optional-compute-data-type",headingTag:"h2"}}),h=new xe({props:{code:"aW1wb3J0JTIwdG9yY2glMEFmcm9tJTIwdHJhbnNmb3JtZXJzJTIwaW1wb3J0JTIwQml0c0FuZEJ5dGVzQ29uZmlnJTBBJTBBcXVhbnRpemF0aW9uX2NvbmZpZyUyMCUzRCUyMEJpdHNBbmRCeXRlc0NvbmZpZyhsb2FkX2luXzRiaXQlM0RUcnVlJTJDJTIwYm5iXzRiaXRfY29tcHV0ZV9kdHlwZSUzRHRvcmNoLmJmbG9hdDE2KQ==",highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> BitsAndBytesConfig

quantization_config = BitsAndBytesConfig(load_in_4bit=<span class="hljs-literal">True</span>, bnb_4bit_compute_dtype=torch.bfloat16)`,wrap:!1}}),g=new k({props:{title:"PEFT",local:"peft",headingTag:"h1"}}),w=new k({props:{title:"Accelerate",local:"accelerate",headingTag:"h1"}}),_=new k({props:{title:"Trainer for the optimizers",local:"trainer-for-the-optimizers",headingTag:"h1"}}),H=new k({props:{title:"Blog posts",local:"blog-posts",headingTag:"h1"}}),{c(){f=o("meta"),X=a(),q=o("p"),Z=a(),P(p.$$.fragment),F=a(),m=o("p"),m.textContent=le,I=a(),c=o("p"),c.innerHTML=re,j=a(),d=o("p"),d.innerHTML=fe,Q=a(),P(u.$$.fragment),U=a(),b=o("p"),b.innerHTML=pe,N=a(),P(h.$$.fragment),S=a(),P(g.$$.fragment),V=a(),y=o("p"),y.innerHTML=me,W=a(),$=o("p"),$.innerHTML=ce,G=a(),P(w.$$.fragment),Y=a(),T=o("p"),T.textContent=de,D=a(),v=o("p"),v.innerHTML=ue,K=a(),P(_.$$.fragment),O=a(),C=o("p"),C.innerHTML=be,ee=a(),L=o("p"),L.innerHTML=he,te=a(),M=o("p"),M.innerHTML=ge,ie=a(),P(H.$$.fragment),ne=a(),x=o("ul"),x.innerHTML=ye,ae=a(),E=o("p"),this.h()},l(e){const t=Me("svelte-u9bgzb",document.head);f=l(t,"META",{name:!0,content:!0}),t.forEach(i),X=s(e),q=l(e,"P",{}),$e(q).forEach(i),Z=s(e),z(p.$$.fragment,e),F=s(e),m=l(e,"P",{"data-svelte-h":!0}),r(m)!=="svelte-umvy4"&&(m.textContent=le),I=s(e),c=l(e,"P",{"data-svelte-h":!0}),r(c)!=="svelte-dleetj"&&(c.innerHTML=re),j=s(e),d=l(e,"P",{"data-svelte-h":!0}),r(d)!=="svelte-198hir6"&&(d.innerHTML=fe),Q=s(e),z(u.$$.fragment,e),U=s(e),b=l(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-q0cjog"&&(b.innerHTML=pe),N=s(e),z(h.$$.fragment,e),S=s(e),z(g.$$.fragment,e),V=s(e),y=l(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1pzo32b"&&(y.innerHTML=me),W=s(e),$=l(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-ss69sb"&&($.innerHTML=ce),G=s(e),z(w.$$.fragment,e),Y=s(e),T=l(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-yklqdi"&&(T.textContent=de),D=s(e),v=l(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-f0p65c"&&(v.innerHTML=ue),K=s(e),z(_.$$.fragment,e),O=s(e),C=l(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1ydhatv"&&(C.innerHTML=be),ee=s(e),L=l(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-l324p4"&&(L.innerHTML=he),te=s(e),M=l(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1auupce"&&(M.innerHTML=ge),ie=s(e),z(H.$$.fragment,e),ne=s(e),x=l(e,"UL",{"data-svelte-h":!0}),r(x)!=="svelte-1opwyey"&&(x.innerHTML=ye),ae=s(e),E=l(e,"P",{}),$e(E).forEach(i),this.h()},h(){we(f,"name","hf:doc:metadata"),we(f,"content",ze)},m(e,t){He(document.head,f),n(e,X,t),n(e,q,t),n(e,Z,t),A(p,e,t),n(e,F,t),n(e,m,t),n(e,I,t),n(e,c,t),n(e,j,t),n(e,d,t),n(e,Q,t),A(u,e,t),n(e,U,t),n(e,b,t),n(e,N,t),A(h,e,t),n(e,S,t),A(g,e,t),n(e,V,t),n(e,y,t),n(e,W,t),n(e,$,t),n(e,G,t),A(w,e,t),n(e,Y,t),n(e,T,t),n(e,D,t),n(e,v,t),n(e,K,t),A(_,e,t),n(e,O,t),n(e,C,t),n(e,ee,t),n(e,L,t),n(e,te,t),n(e,M,t),n(e,ie,t),A(H,e,t),n(e,ne,t),n(e,x,t),n(e,ae,t),n(e,E,t),se=!0},p:ve,i(e){se||(B(p.$$.fragment,e),B(u.$$.fragment,e),B(h.$$.fragment,e),B(g.$$.fragment,e),B(w.$$.fragment,e),B(_.$$.fragment,e),B(H.$$.fragment,e),se=!0)},o(e){J(p.$$.fragment,e),J(u.$$.fragment,e),J(h.$$.fragment,e),J(g.$$.fragment,e),J(w.$$.fragment,e),J(_.$$.fragment,e),J(H.$$.fragment,e),se=!1},d(e){e&&(i(X),i(q),i(Z),i(F),i(m),i(I),i(c),i(j),i(d),i(Q),i(U),i(b),i(N),i(S),i(V),i(y),i(W),i($),i(G),i(Y),i(T),i(D),i(v),i(K),i(O),i(C),i(ee),i(L),i(te),i(M),i(ie),i(ne),i(x),i(ae),i(E)),i(f),R(p,e),R(u,e),R(h,e),R(g,e),R(w,e),R(_,e),R(H,e)}}}const ze='{"title":"Transformers","local":"transformers","sections":[{"title":"Beware: bf16 is optional compute data type","local":"beware-bf16-is-optional-compute-data-type","sections":[],"depth":2}],"depth":1}';function Ae(oe){return _e(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qe extends Ce{constructor(f){super(),Le(this,f,Ae,Pe,Te,{})}}export{qe as component};
